#ifndef DIZIONARIO_CHIUSO_H
#define DIZIONARIO_CHIUSO_H

/* 
DIZIONARIO = VETTORE DI PUNTATORE A CELLE;
OGNI CELLA CONITENE DATI DI UN ELEMEMTNO DEL DIZIONARIO.
COLLISIONI CON SCANSIONE LINERARE.
USO UN VETTORE DI INTERI PER DISTINGUERE SE LA CELLA DEL VETTORE
DIZIONARIO E' VUOTA=0 O CANCELLATA=1;

HO VETTORE DI N CELLE DISPONIBILI DOVE INSERIRE LE CELLE LEGATE 
AI VARI ELEMNTI DELL'INSIEME.
IN CASO DI COLLISIONE IL PROBLEMA E' GESTITO AVANZANDO NEL VETTORE;
FINO A QUANDO SI TROVA UNA CELLA CON VALORE VUOTO

PER DISTINGUERE LA CELLA VUOTA DA CANCELLATA :
// vettore "STATO" parallelo al precedente che fornisce 
// informazioni sullo stao di ogni cella del vettore dizionario
// stato[i]=0 se dizionario[i]  libera;
// stato[i]=1 se dizionario[i]  cancellata
*/
#include "hash.h"

typedef int tipoelem; //tipoelem  un intero
const int MAX=10;// dimensione vettore contenente le celle del dizionario

class Cella{
public:
    void setlabel(tipoelem);
    tipoelem getlabel();
private:
    tipoelem label;
};

//typedef Cella * Cpunt;
typedef bool boolean;

class Dizionario{
public:
    void creadizionario();
    boolean appartiene(tipoelem);
    void inserisci(tipoelem);
    void cancella(tipoelem);
    void scandisci(tipoelem,int &,int &);//gestione collisioni
//    int hash(tipoelem);
private:
    Cella * dizionario[MAX];
    int stato[MAX]; //stato delle celle del vettore del dizionario
    void stampatutto();//funzione di servizio che visualizza lo stato del dizionario, creata esclusivamente per fini di sviluppo
};

#endif //DIZIONARIO_CHIUSO_H
